package com.purewhite.ywc.frame.ui.adapter;


import android.view.View;

import androidx.databinding.ViewDataBinding;

import com.purewhite.ywc.frame.R;
import com.purewhite.ywc.frame.databinding.AdapterAndroidStudyBinding;
import com.purewhite.ywc.purewhitelibrary.adapter.recyclerview.BindAdapter;
import com.purewhite.ywc.purewhitelibrary.adapter.viewholder.BindHolder;

import java.util.List;

public class AndroidStudyAdapter extends BindAdapter<String> {

    private List<String> listUri;
    public AndroidStudyAdapter(List<String> list,List<String> listUri) {
        super(list);
        this.listUri=listUri;
        addLayout(R.layout.adapter_android_study);
    }

    public String obtainUri(int position)
    {
        if (getItemCount()>position)
            return listUri.get(position);
        return "";
    }



    @Override
    protected void onData(BindHolder holder, int position, String s,int itemType) {
        ViewDataBinding binding = holder.getBinding();
        if (binding instanceof AdapterAndroidStudyBinding)
        {
            initBind(((AdapterAndroidStudyBinding) binding),position,s);
        }
    }

    private void initBind(AdapterAndroidStudyBinding binding, int position, String s) {
        binding.androidStudyText.setText(s);
        binding.viewLine.setVisibility(position==obtainDataCount()-1?View.GONE:View.VISIBLE);
    }

}
